#include "..\defines.h"

#ifdef INCLUDE_REBUILD

#ifdef GCC_RUNTIME
#include <stdio.h>
#endif

namespace bnf {

extern "C" char* SymbolNames;
extern "C" int SymbolNameSizeCopy;
	
int CaseSensitive;
char* lpSeperatorBytes;
int nSeperatorCount = 0;
char* lpComments;

char ConfigFile[32] = "Build\\bnf.cfg";

int SymbolNameSizeCopy;
int SymbolNameSize;
char** SymbolPointer;

bool Parse = false;
bool List = false;

#include "main.h"

extern int InitGrammar();
extern int ExitGrammar();
extern int Split(char* FileName);
extern int ListSource(char* FileName);

void ReadConfigPrepareString(char* lpStr)
{
	int i, j;

	j = strlen(lpStr);
	lpStr[j] = lpStr[j + 1] = 0;
	
	for (i = 0;i < j;i++)
	{
		if (lpStr[i] == ',')
		{
			lpStr[i] = 0;
		}
	}
}

int ReadConfig()
{
	char* PathName;
	char* pTemp;
	int nTemp;

	GetPath(&PathName, ConfigFile);
	CaseSensitive = GetPrivateProfileInt("Config", "CaseSensitive", 1, PathName);

	if (GetPrivateProfileStringA("Config", "SeperatorBytes", &lpSeperatorBytes))
	{
		return(1);
	}

	ReadConfigPrepareString(lpSeperatorBytes);

	pTemp = lpSeperatorBytes;
	while(*pTemp)
	{
		nTemp = atoi(pTemp);
		pTemp += strlen(pTemp) + 1;
		lpSeperatorBytes[nSeperatorCount] = (char) nTemp;
		nSeperatorCount++;
	}

	if (GetPrivateProfileStringA("Config", "Comment", &lpComments))
	{
		return(1);
	}

	ReadConfigPrepareString(lpComments);

	freel(PathName);
	return(0);
}

#include "interface.h"

}

#endif