void str_replace(char val1, char val2, char* val, int len = 0)
{
	int i;

	if (len == 0)
	{
		len = strlen(val);
	}

	for (i = 0;i < len;i++)
	{
		if (val[i] == val1)
		{
			val[i] = val2;
		}
	}
}

void saverep(char* repfile, bool force = false, CharTemplate* ForceTemplate = NULL, int Count = 1, int rename = 0)
{
	FILE* fRe;
	string fullrepfile = "Save\\";
	int i;
	GroupTemplate tmpGroup;

	CharTemplate* reheader = (ForceTemplate == NULL ? (&USE_NAMESPACE::reheader) : ForceTemplate);

	if (reproduce == 1 || reproduceisaac || force)
	{
		if (Count != GT.CharCount)
		{
			tmpGroup.CharCount = Count;
			tmpGroup.FullCR = Characters[0].HG;
		}
		else
		{
			CopyMemory(&tmpGroup, &GT, sizeof(GroupTemplate));
		}
		for (i = 0;i < Count;i++)
		{
			if (reheader[i].TemplateType == '0')
			{
				if (ForceTemplate)
				{
					retemp = (unsigned int*) reheader[i].re.retemp;
					prepos = (unsigned int*) &reheader[i].re.repos;
				}
				retemp[*prepos] = (unsigned int) -100;
				CopyMemory(reheader[i].re.retemp, retemp, REPRODUCE_SAVE * sizeof(int));
			}
		}

		if (strlen(repfile))
		{
			fullrepfile += repfile;
			str_replace('\\', '-', fullrepfile.buffer + 5);

			if (rename)
			{
				fRe = fopen(fullrepfile, "r");
				if (fRe != 0)
				{
					int tmpLen;
					if (stricmp(fullrepfile.buffer + max(0, (signed) strlen(fullrepfile) - 4), ".rep") == 0)
					{
						tmpLen = strlen(fullrepfile) - 4;
					}
					else
					{
						tmpLen = strlen(fullrepfile);
					}
					int tmpCount = 0;
					char tmpBuffer[10];
					do
					{
						fclose(fRe);
						strcut(fullrepfile, tmpLen);
						itoa(tmpCount++, tmpBuffer, 10);
						fullrepfile += tmpBuffer;
						fullrepfile += ".rep";
						fRe = fopen(fullrepfile, "r");
					} while (fRe != 0);
				}
			}

			fRe = fopen(fullrepfile, "wb");
			if (fRe == 0)
			{
				printf("Fatal Error\nCould not Open Output File\n");
				getchar();
				return;
			}

			fwrite("DNDR", 4, 1, fRe);
			fwrite(&tmpGroup, sizeof(GroupTemplate), 1, fRe);

			for (i = 0;i < Count;i++)
			{
				fwrite(&reheader[i], sizeof(CharTemplate), 1, fRe);
			}

			fclose(fRe);
			if (loop == 0)
			{
				printf("Reproduction file has been saved as %s\n", fullrepfile.buffer + 5);
			}
		}
	}
}

void quitprog(bool save = true)
{
	int i, j;
	loop = 0;
	if (InitPassed && save)
	{
		saverep("error.rep", false, NULL, 1, 1);
#ifndef DEBUG_RUNTIME
#ifdef BUILD_DEBUG
		printf("Press [D] to reproduce this character in Debug Runtime\n");

		fflush(stdin);
		i = getch();

		if ((i | 32) == 'd')
		{
			int argc = 0;;
			char** argv = NULL;

			UseReHeaderSave = true;
			CopyMemory(&ReHeaderSave, &reheader, sizeof(CharTemplate));

			Runtime(0, argc, argv);
		}
#endif
#endif
	}
	printf("Quitting due to error\n");
	SetConsoleActiveScreenBuffer(GetStdHandle(STD_OUTPUT_HANDLE));
	fflush(stdin);
	i = getchar();
	ZeroMemory(&j, sizeof(int));
	i /= j;
	printf("%d", i);

	return;
}

inline int TwoCharToInt(char* val, bool varsize = false)
{
	if (varsize == false || strlen(val) != 1)
	{
		return((int) (*((unsigned short*) val)));
	}
	else
	{
		return((int) val[0]);
	}
}

int substr_count(char val1, char* val, int len = 0)
{
	int i, num = 0;

	if (len == 0)
	{
		len = strlen(val);
	}

	for (i = 0;i < len;i++)
	{
		if (val[i] == val1)
		{
			num++;
		}
	}
	return(num);
}

unsigned int hoch(unsigned int base, unsigned int exp)
{
	unsigned int i;
	unsigned int temp = 1;
	for (i = 0;i < exp;i++)
	{
		temp *= base;
	}
	return(temp);
}

unsigned int intpart(unsigned int val, unsigned int part)
{
	val = val % (hoch(16, part));
	val = val / (hoch(16, part - 1));
	return(val);
}

int SummarizeArray(int* Array, int Number)
{
	int temp = 0, i;
	for (i = 0;i < Number;i++)
	{
		temp += Array[i];
	}
	return(temp);
}

int GreaterZero(int val)
{
	if (val > 1)
	{
		return(val);
	}
	else
	{
		return(1);
	}
}

int HighestVal(int* Array, int Number)
{
	int temp = 0, tempnum = 0, i;
	for (i = 0;i < Number;i++)
	{
		if (Array[i] > temp)
		{
			temp = Array[i];
			tempnum = i;
		}
	}
	return(tempnum);
}

double absd(double val)
{
	return((val < 0 ? - val : val));
}

int Enhence(int Level)
{
	int i;
	int probs[7];

	if (Level > 20)
	{
		if (boolrand("Artifakt?" , max(1, 55 - Level), Level - 20))
		{
			return(6);
		}
	}

	for (i = 0;i < 7;i++)
	{
		probs[i] = (int) ((double) 50000 / (((double) Level / 4 - i) * ((double) Level / 4 - i) * absd((double) Level / 4 - i) * 4 + 1));
	}

	probs[6] /= 1000;

	i = AdvancedRand(7, probs, sizeof(int), "", 0, "Verbesserung Auswhlen!");
	return(i);
}

void SecureMultiply(int* Value, int Factor)
{
	if (*Value > 500000000 / Factor)
	{
		*Value = 500000000;
	}
	else
	{
		*Value *= Factor;
	}
}

void InsertEquip(clsChar* TargetStruct, int SourceID, int DestID, int AdjustMoney = 1)
{
	ZeroMemory(&TargetStruct->Equipment[DestID], sizeof(clsEquip));

	TargetStruct->Equipment[DestID].ID = SourceID;
	TargetStruct->Equipment[DestID].Armor = Source.EquipSource[SourceID].Armor;
	TargetStruct->Equipment[DestID].AttackType = Source.EquipSource[SourceID].AttackType;
	TargetStruct->Equipment[DestID].Critical = Source.EquipSource[SourceID].Critical;
	TargetStruct->Equipment[DestID].CriticalMultiplier = Source.EquipSource[SourceID].CriticalMultiplier;
	TargetStruct->Equipment[DestID].CriticalMultiplier2 = Source.EquipSource[SourceID].CriticalMultiplier2;
	TargetStruct->Equipment[DestID].Damage1 = Source.EquipSource[SourceID].Damage1;
	TargetStruct->Equipment[DestID].Damage2 = Source.EquipSource[SourceID].Damage2;
	TargetStruct->Equipment[DestID].Damage3 = Source.EquipSource[SourceID].Damage3;
	TargetStruct->Equipment[DestID].EquipType = Source.EquipSource[SourceID].EquipType;
	TargetStruct->Equipment[DestID].Malus = Source.EquipSource[SourceID].Malus;
	TargetStruct->Equipment[DestID].MaxDex = Source.EquipSource[SourceID].MaxDex;
	TargetStruct->Equipment[DestID].Metallic = Source.EquipSource[SourceID].Metallic;
	TargetStruct->Equipment[DestID].Size = Source.EquipSource[SourceID].Size;
	TargetStruct->Equipment[DestID].SpellFailure = Source.EquipSource[SourceID].SpellFailure;
	TargetStruct->Equipment[DestID].Type = Source.EquipSource[SourceID].Type;

	if (AdjustMoney)
	{
		TargetStruct->MoneyRest -= (TargetStruct->Equipment[DestID].BaseValue = Source.EquipSource[SourceID].Price);
		if (TargetStruct->MoneyRest < 0)
		{
			TargetStruct->Money -= TargetStruct->MoneyRest;
			TargetStruct->MoneyRest = 0;
		}
	}
}

int mCheckCharsI, mCheckCharsResult;
#define mCheckChars(Value) \
{ \
	mCheckCharsResult = 0; \
	for(mCheckCharsI = 0;mCheckCharsI < TargetStruct->ClassCount;mCheckCharsI++) \
	{ \
		if (Source.CharSource[TargetStruct->Classes[mCheckCharsI]].Value) \
		{ \
			mCheckCharsResult = 1; \
			break; \
		} \
	} \
}
